# This file is a template, and might need editing before it works on your project.
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Getting-Started.gitlab-ci.yml

# This is a sample GitLab CI/CD configuration file that should run without any modifications.
# It demonstrates a basic 3 stage CI/CD pipeline. Instead of real tests or scripts,
# it uses echo commands to simulate the pipeline execution.
#
# A pipeline is composed of independent jobs that run scripts, grouped into stages.
# Stages run in sequential order, but jobs within stages run in parallel.
#
# For more information, see: https://docs.gitlab.com/ee/ci/yaml/index.html#stages

image: maven:latest

stages:          # List of stages for jobs, and their order of execution
  - build
  - test
  - quality
  - deploy

build-job:       # This job runs in the build stage, which runs first.
  stage: build
  script:
    - mvn compile

unit-test-job:   # This job runs in the test stage.
  stage: test    # It only starts when the job in the build stage completes successfully.
  script:
    - mvn test 


deploy-job:      # This job runs in the deploy stage.
  stage: deploy  # It only runs when *both* jobs in the test stage complete successfully.
  script:
    - echo "Deploying application..."
    - echo "Application successfully deployed."

code_quality-job: 
  stage: quality
  tags:
    - gitlab-org 
  variables:
    SONAR_TOKEN: "5c763867fa174d226d1b03d8469c536084a2073a"
    SONAR_HOST_URL: "https://sonarcloud.io/"
    SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"
    GIT_DEPTH: "0"
  cache:
      key: "${CI_JOB_NAME}"
      paths:
        - .sonar/cache
  script:
    - mvn verify sonar:sonar -Dsonar.projectKey=benadjaoud.wissam_ProjetCleanCode
